#!/usr/bin/perl



############################### This program is free software; you can redistribute it and/or modify
############################### it under the terms of the GNU General Public License as published by
############################### the Free Software Foundation; either version 2 of the License, or
############################### (at your option) any later version.
############################### 
############################### This program is distributed in the hope that it will be useful,
############################### but WITHOUT ANY WARRANTY; without even the implied warranty of
############################### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
############################### GNU General Public License for more details.
############################### 
############################### You should have received a copy of the GNU General Public License
############################### along with this program; if not, write to the Free Software
############################### Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
###############################
###############################
###############################
############################### Copyright 2010 Damon P. Little



############################### DETERMINE OPTIONS AND ANALYSIS TYPE
my $i = ();
my $c = 0;
my $s = 0;
my $q = 30;
my $x = 2;

for(my $k = 0; $k <= $#ARGV; $k++){
	if($ARGV[$k] eq "-i"){
		if((-e $ARGV[$k+1]) && ((-s $ARGV[$k+1]) < 50000)){
			$i = $ARGV[$k+1];
			}
		}
	if($ARGV[$k] eq "-c"){
		$ARGV[$k+1] =~ tr/[0-9]//cd;
		if(($ARGV[$k+1] > 0) && ($ARGV[$k+1] < 100000)){
			$c = $ARGV[$k+1];
			}
		}
	if($ARGV[$k] eq "-s"){
		$s = 1;
		}
	if($ARGV[$k] eq "-q"){
		$ARGV[$k+1] =~ tr/[0-9]//cd;
		if(($ARGV[$k+1] > 0) && ($ARGV[$k+1] < 100)){
			$q = $ARGV[$k+1];
			}
		}
	if($ARGV[$k] eq "-x"){
		$ARGV[$k+1] =~ tr/[0-9].//cd;
		if(($ARGV[$k+1] > 0) && ($ARGV[$k+1] < 1000)){
			$x = $ARGV[$k+1];
			}
		}	
	}



if(length($i)){ ############################### PROPER INPUT GIVEN
	
	
	
	############################### READ CAF
	open(INFILE, "$i") || die("Could not open $i!");
	my @file = split(/\012\015?|\015\012?/, join('', <INFILE>));
	close(INFILE);
	
	
	
	############################### PARSE CAF
	my $S = 0;	
	my $DNA = ();
	my $contig = 0;
	my $read = 0;
	my $seq = 0;
	my $qual = 0;
	for(my $j = 0; $j <= $#file; $j++){
		my @bits = split(/ /, $file[$j]);
		if($file[$j] eq "Is_contig"){
			$contig = 1;
			$read = 0;
			}
		if($file[$j] eq "Is_read"){
			$contig = 0;
			$read = 1;
			}
		if($contig && (length($file[$j]) == 0) && !$c && $seq){
			$seq = 0;
			}	
		if($seq){
			$DNA .= $file[$j];
			}
		if($contig && ($bits[0] eq "DNA") && !$c){
			$seq = 1;
			}
		if($read && (length($file[$j]) == 0) && $qual){
			$qual = 0;
			}	
		if($qual){
			for(my $k = 0; $k <= $#bits; $k++){
				if($bits[$k] >= $q){
					if($s){
						if($bits[$k] != 60){
							$S++;
							}
						} else {
							$S++;
							}
					}
				}
			}
		if($read && ($bits[0] eq "BaseQuality")){
			$qual = 1;
			}	
		}
	
	
	
	############################### COMPUTE B
	if(!$c){
		$c = length($DNA);
		}
	if($c && $x){
		my $B = sprintf("%.3f", ($S/($c*$x)));
		print("$B\n");
		} else {
			print("ERROR (i = $1; c = $c; q = $q; x = $x; S = $S)\n");
			}
	
	
	
	} else { ############################### INPUT OPTIONS NOT GIVEN
		print("\nA PERL script for calculating barcode sequence quality (B) from \nCommon Assembly Format files (CAF; output by e.g. Sequencher).\n\n");
		print("USAGE: B.pl -i in-file.caf [-c ###] [-s] [-q ###] [-x ###]\n");
		print("WHERE:\t-i\tis a CAF input file\n\t-c\tis expected contig length (default = use observed)\n\t-s\tattempt to manually edited bases as QV 0 (Sequencher outputs\n\t\tthem as QV 60; default = do not attempt correction; WARNING: the\n\t\tuse of this option may have bad unintended consequences)\n\t-q\tis desired cutoff value (default = $q)\n\t-x\tis the expected coverage (default = $x)\n\n");
		print("This script is distributed under the GNU General Public License.\n\n");
		print("If you use this script, please cite:\n\nLittle, D. P. 2010. A unified index of sequence quality and contig overlap for\nDNA barcoding. Bioinformatics. 26 (21): 2780-2781.\n\n");
		}
		
		
		
exit;
